<template>
  <div ref="chartRef" :style="{ height, width }"></div>
</template>
<script lang="ts">
  import { defineComponent, PropType, ref, Ref, reactive, watchEffect } from 'vue';
  import { useECharts } from '/@/hooks/web/useECharts';
  import { cloneDeep } from 'lodash-es';
  export default defineComponent({
    name: 'bar',
    props: {
      chartData: {
        type: Array,
        default: () => [],
      },
      option: {
        type: Object,
        default: () => ({}),
      },
      width: {
        type: String as PropType<string>,
        default: '100%',
      },
      height: {
        type: String as PropType<string>,
        default: 'calc(100vh - 78px)',
      },
    },
    setup(props) {
      const chartRef = ref<HTMLDivElement | null>(null);
      const { setOptions, echarts } = useECharts(chartRef as Ref<HTMLDivElement>);
      const option = reactive({
        tooltip: {
          trigger: 'axis',
          axisPointer: {
            type: 'shadow',
            label: {
              show: true,
              backgroundColor: '#333',
            },
          },
        },
        legend: {
          data: ['得分', '扣分']
        },
        grid: {
          left: '3%',
          right: '4%',
          bottom: '39%',
          containLabel: true
        },
        xAxis: {
          type: 'value',
           
        },
        yAxis: {
          
          type: 'category',
          data: [],
        },
        series: [
          {
            name: '得分',
            type: 'bar',
            stack: '总量',
            label: {
                show: true,
                position: 'insideRight'
                
            
            },
            data: [],
            showBackground: true,
            backgroundStyle: {
              color: 'rgba(180, 180, 180, 0.2)'
            }
          },
          {
            name: '扣分',
            type: 'bar',
            stack: '总量',
            label: {
                show: true,
                position: 'insideRight'
            },
            data: [],
          },

        ],
      });

      watchEffect(() => {
        props.chartData && initCharts();
      });

      function initCharts() {
        if (props.option) {
          Object.assign(option, cloneDeep(props.option));
        }
        let seriesData = props.chartData.map((item) => {
          return item.value;
        });
        let seriesDatast = props.chartData.map((item) => {
          return item.stvalue;
        });
        let yAxisData = props.chartData.map((item) => {
          return item.name;
        });
        //console.log('-------------option.series[0].name: ', option.series[0].name);
        option.series[0].data = seriesData;
        option.series[1].data = seriesDatast;
        option.yAxis.data = yAxisData;
        setOptions(option);
      }
      return { chartRef };
    },
  });
</script>
